local MAJOR, MINOR = "LibFail-1.0", tonumber("81") or 999

assert(LibStub, MAJOR.." requires LibStub")

local lib = LibStub:NewLibrary(MAJOR, MINOR)
if not lib then return end

local callbacks = LibStub("CallbackHandler-1.0"):New(lib)

lib.frame = lib.frame or CreateFrame("Frame")

local frame = lib.frame
frame:RegisterEvent("PLAYER_ENTERING_WORLD")

--- Fail Events.
--@description The list of supported events
--@class table
--@name fail_events
--@field 1  Fail_Deconstructor_Light
--@field 2  Fail_Deconstructor_Void
--@field 3  Fail_Frogger
--@field 4  Fail_Heigan_Dance
--@field 5  Fail_KelThuzad_VoidZone
--@field 6  Fail_Mimiron_BombBots
--@field 7  Fail_Mimiron_Rocket
--@field 8  Fail_Mimiron_Shock
--@field 9  Fail_Sapphiron_Breath
--@field 10 Fail_Sartharion_LavaWaves
--@field 11 Fail_Sartharion_VoidZone
--@field 12 Fail_Thaddius_Jump
--@field 13 Fail_Thaddius_PolaritySwitch
--@field 14 Fail_Thorim_LightningChain
--@field 15 Fail_Thorim_LightningCharge
--@field 16 Fail_Thorim_Smash
--@field 17 Fail_Vezax_ShadowCrash
--@field 18 Fail_Vezax_Saronite
--@field 19 Fail_Hodir_FlashFreeze
--@field 20 Fail_Vezax_Leech
--@field 21 Fail_Mimiron_LaserBarrage
--@field 22 Fail_Mimiron_Flames
--@field 23 Fail_Council_Overload
--@field 24 Fail_Hodir_Icicle
--@field 25 Fail_Freya_Sunbeam
--@field 26 Fail_Freya_NatureBomb
--@field 27 Fail_Thorim_Blizzard
--@field 28 Fail_Yogg_Sanity
--@field 29 Fail_Yogg_DeathRay
--@field 30 Fail_Racorscale_Flame
--@field 31 Fail_Kologarn_Eyebeam
--@field 32 Fail_Auriaya_Voidzone
--@field 33 Fail_Hodir_BitingCold
--@field 34 Fail_Malygos_Dot
--@field 35 Fail_Gorehowl_FireBomb
--@field 36 Fail_Acidmaw_SlimePool
--@field 37 Fail_Acidmaw_AcidicSpew
--@field 38 Fail_Acidmaw_ParalyticToxin
--@field 39 Fail_Dreadscale_MoltenSpew
--@field 40 Fail_Icehowl_Trample
--@field 41 Fail_Jaraxxus_FelflameInfernal
--@field 42 Fail_Jaraxxus_LegionFlame
--@field 43 Fail_FactionChampions_Hellfire
--@field 44 Fail_Valkyr_Orb
--@field 45 Fail_Valkyr_Vortex
--@field 46 Fail_Anubarak_Impale
--@field 47 Fail_Mimiron_WaterSpray
--@field 48 Fail_Mimiron_ProximityMine
--@field 49 Fail_Mimiron_FrostBomb
--@field 50 Fail_Yogg_LunaticGaze
--@field 51 Fail_Algalon_BigBang
--@field 52 Fail_Mimiron_Siren
--@field 53 Fail_Koralon_MeteorFist
--@field 54 Fail_Horsemen_VoideZone
--@field 55 Fail_Horsemen_Mark
--@field 56 Fail_Onyxia_FlameBreath
--@field 57 Fail_Onyxia_TailSweep
--@field 58 Fail_Archavon_ChokingCloud
--@field 59 Fail_Emalon_LightningNova
--@field 60 Fail_Emalon_ChainLightning
--@field 61 Fail_Koralon_FlameCinder
--@field 62 Fail_Auriaya_SonicScreech
--@field 63 Fail_Onyxia_DeepBreath
local fail_events = {
    "Fail_Deconstructor_Light",
    "Fail_Deconstructor_Void",
    "Fail_Frogger",
    "Fail_Heigan_Dance",
    "Fail_KelThuzad_VoidZone",
    "Fail_Mimiron_BombBots",
    "Fail_Mimiron_Rocket",
    "Fail_Mimiron_Shock",
    "Fail_Sapphiron_Breath",
    "Fail_Sartharion_LavaWaves",
    "Fail_Sartharion_VoidZone",
    "Fail_Thaddius_Jump",
    "Fail_Thaddius_PolaritySwitch",
    "Fail_Thorim_LightningChain",
    "Fail_Thorim_LightningCharge",
    "Fail_Thorim_Smash",
    "Fail_Vezax_ShadowCrash",
    "Fail_Vezax_Saronite",
    "Fail_Vezax_Leech",
    "Fail_Hodir_FlashFreeze",
    "Fail_Mimiron_LaserBarrage",
    "Fail_Mimiron_Flames",
    "Fail_Council_Overload",
    "Fail_Hodir_Icicle",
    "Fail_Freya_Sunbeam",
    "Fail_Freya_NatureBomb",
    "Fail_Thorim_Blizzard",
    "Fail_Yogg_Sanity",
    "Fail_Yogg_DeathRay",
    "Fail_Racorscale_Flame",
    "Fail_Kologarn_Eyebeam",
    "Fail_Auriaya_Voidzone",
    "Fail_Hodir_BitingCold",
    "Fail_Malygos_Dot",
    "Fail_Gorehowl_FireBomb",
    "Fail_Acidmaw_SlimePool",
    "Fail_Acidmaw_AcidicSpew",
    "Fail_Acidmaw_ParalyticToxin",
    "Fail_Dreadscale_MoltenSpew",
    "Fail_Icehowl_Trample",
    "Fail_Jaraxxus_FelflameInfernal",
    "Fail_Jaraxxus_LegionFlame",
    "Fail_FactionChampions_Hellfire",
    "Fail_Valkyr_Orb",
    "Fail_Valkyr_Vortex",
    "Fail_Anubarak_Impale",
    "Fail_Mimiron_WaterSpray",
    "Fail_Mimiron_ProximityMine",
    "Fail_Mimiron_FrostBomb",
    "Fail_Yogg_LunaticGaze",
    "Fail_Algalon_BigBang",
    "Fail_Mimiron_Siren",
    "Fail_Koralon_MeteorFist",
    "Fail_Horsemen_VoideZone",
    "Fail_Horsemen_Mark",
    "Fail_Onyxia_FlameBreath",
    "Fail_Onyxia_TailSweep",
    "Fail_Archavon_ChokingCloud",
    "Fail_Emalon_LightningNova",
    "Fail_Emalon_ChainLightning",
    "Fail_Koralon_FlameCinder",
    "Fail_Auriaya_SonicScreech",
    "Fail_Onyxia_DeepBreath",
}

--[===[@debug@
function lib:Test(overrideName)
    local e = math.floor(math.random() * #fail_events) + 1
    local p = math.floor(math.random() * 5) + 1

    self:FailEvent(fail_events[e], overrideName or "Test"..p)
end
--@end-debug@]===]

-- Not sure if this really gets used
local survivable_fails = {
    Fail_Sartharion_LavaWaves = true,
    Fail_Sartharion_VoidZone = true,
    Fail_Heigan_Dance = true,
    Fail_Thaddius_PolaritySwitch = true,
    Fail_Thaddius_Jump = true,
    Fail_Deconstructor_Light = true,
    Fail_Deconstructor_Void = true,
    Fail_Vezax_ShadowCrash = true,
    Fail_Hodir_FlashFreeze = true,
}

-- The distinction between the mass/group is there is 1 fail
-- for N people in a group fail. For mass fails, there are N fails
-- for N people.

-- NYI, fails which have a group component
-- that is *part* of the fail
-- eg. chain lightning
local group_fails = {
    Fail_Thorim_LightningChain = true,
}

-- NYI, fails which tend to happen to alot of
-- people at the same time - but are still individual fails
-- eg. lava waves (this info may be redundant)
--local mass_fails = {
--    Fail_Sartharion_LavaWaves = true,
--    Fail_Heigan_Dance = true,
--    Fail_Sartharion_VoidZone = true,
--    Fail_Vezax_ShadowCrash = true
--}

local zones_with_fails = {
    ["Onyxia's Lair"] = {
        "Fail_Onyxia_FlameBreath",
        "Fail_Onyxia_TailSweep",
        "Fail_Onyxia_DeepBreath",
    },
    ["Trial of the Crusader"] = {
        "Fail_Gorehowl_FireBomb",
        "Fail_Acidmaw_SlimePool",
        "Fail_Acidmaw_AcidicSpew",
        "Fail_Acidmaw_ParalyticToxin",
        "Fail_Dreadscale_MoltenSpew",
        "Fail_Icehowl_Trample",
        "Fail_Jaraxxus_FelflameInfernal",
        "Fail_Jaraxxus_LegionFlame",
        "Fail_FactionChampions_Hellfire",
        "Fail_Valkyr_Orb",
        "Fail_Valkyr_Vortex",
        "Fail_Anubarak_Impale",
    },
    Ulduar = {
        "Fail_Deconstructor_Light",
        "Fail_Deconstructor_Void",
        "Fail_Hodir_FlashFreeze",
        "Fail_Hodir_BitingCold",
        "Fail_Hodir_Icicle",
        "Fail_Mimiron_BombBots",
        "Fail_Mimiron_Rocket",
        "Fail_Mimiron_Shock",
        "Fail_Mimiron_LaserBarrage",
        "Fail_Mimiron_Flames",
        "Fail_Thorim_LightningChain",
        "Fail_Thorim_LightningCharge",
        "Fail_Thorim_Smash",
        "Fail_Thorim_Blizzard",
        "Fail_Vezax_Leech",
        "Fail_Vezax_ShadowCrash",
        "Fail_Vezax_Saronite",
        "Fail_Council_Overload",
        "Fail_Freya_Sunbeam",
        "Fail_Freya_NatureBomb",
        "Fail_Yogg_Sanity",
        "Fail_Yogg_DeathRay",
        "Fail_Racorscale_Flame",
        "Fail_Kologarn_Eyebeam",
        "Fail_Auriaya_Voidzone",
        "Fail_Mimiron_WaterSpray",
        "Fail_Mimiron_ProximityMine",
        "Fail_Mimiron_FrostBomb",
        "Fail_Yogg_LunaticGaze",
        "Fail_Algalon_BigBang",
        "Fail_Mimiron_Siren",
        "Fail_Auriaya_SonicScreech",
    },
    Naxxramas = {
        "Fail_Frogger",
        "Fail_Heigan_Dance",
        "Fail_KelThuzad_VoidZone",
        "Fail_Sapphiron_Breath",
        "Fail_Thaddius_Jump",
        "Fail_Thaddius_PolaritySwitch",
        "Fail_Horsemen_VoideZone",
        "Fail_Horsemen_Mark",
    },
    ["The Obsidian Sanctum"] = {
        "Fail_Sartharion_LavaWaves",
        "Fail_Sartharion_VoidZone"
    },
    ["Eye of Eternity"] = {
        "Fail_Malygos_Dot",
    },
    ["Vault of Archavon"] = {
        "Fail_Koralon_MeteorFist",
        "Fail_Archavon_ChokingCloud",
        "Fail_Emalon_LightningNova",
        "Fail_Emalon_ChainLightning",
        "Fail_Koralon_FlameCinder",
    }
}

--- Get a list of supported events.
-- @see fail_events
-- @return a table of event names which can be fired
function lib:GetSupportedEvents() return fail_events end

--- Get a list of supported events in the current zone
-- @see fail_events
-- @return a table of event names which can be fired
function lib:GetSupportedZoneEvents(name) return zones_with_fails[name] end


--- Is the event survivable.
--@param event an event from the list of supported events
--@return true or nil
function lib:IsSurvivable(event) return survivable_fails[event] end

--- Is the event a failure by a group or an individual. Group failures
-- will come as several events in quick sucession, this gives the host a hint
-- as to how to group and display the events.
--@param event an event from the list of supported events
--@return true or nil
function lib:IsGroupFail(event) return group_fails[event] end


function lib:GoInactive()
    if not self.active then return end

    self:InitVariables()

    self.active = nil

    frame:RegisterEvent("RAID_ROSTER_UPDATE")
    frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    frame:UnregisterEvent("PLAYER_REGEN_ENABLED")

    callbacks:Fire("Fail_Inactive")
end

function lib:InitVariables()
    if not self.active then return end

    self.SquelchFail = {}
    self.FailThrottle = {}
    self.LastTsunami = {}
    self.ChargeCounter = {}
    self.LastCharge = {}
    self.ThaddiusAlive = true;
    self.MalygosAlive = true;
    self.BigbangCasting = false;
    self.ThreePeopleHugging = false;
    self.DeathTime = 0
    self.LastSlime = {}
    self.FroggerTime = {}
    self.LastGravity = {}
    self.LastLight = {}
    self.LunaticGaze = {}
    self.RaidTable = {} -- Mostly for the Auriaya fail, but could be usefull

    self.LastEvent = {}

    -- Last whatever
    for i=1,#fail_events do
        self.LastEvent[fail_events[i]] = {}
    end

end

function lib:InitTimer()
    if not next(self.timers) then return end

    frame:SetScript("OnUpdate", function(self, elapsed)
        for name, timer in pairs(lib.timers) do
            timer.elapsed = timer.elapsed + elapsed
            if timer.elapsed > timer.delay then
                timer.func()
                lib:CancelTimer(name)
            end
        end
    end)
end

function lib:InitRaidTable()
    if next(self.RaidTable) then return end
    local difficulty = GetRaidDifficulty()

    for raidindex = 1, GetNumRaidMembers() do
        local name, _, group, _, _, _, _, online = GetRaidRosterInfo(raidindex)

        if difficulty <= 2 and group <= 2 and online then -- 10 man
            self.RaidTable[name] = true
        elseif group <= 5 and online then -- 25 man
            self.RaidTable[name] = true
        end
    end
end

function lib:ScheduleTimer(name, func, delay)
    if not self.timers then self.timers = {} end
    self.timers[name] = {
        elapsed = 0,
        func = func,
        delay = delay,
    }

    if not frame:GetScript("OnUpdate") then lib:InitTimer() end
end

function lib:CancelTimer(name)
    if not name then 
        self.timers = {}
        return frame:SetScript("OnUpdate", nil) 
    end
    
    self.timers[name] = nil
    if not next(self.timers) then self:CancelTimer() end
end

lib.active = true
lib:GoInactive()

lib.THADDIUS_JUMP_WINDOW = 120
lib.THADDIUS_JUMP_RETRY_WINDOW = 5
lib.FROGGER_DEATH_WINDOW = 4
lib.YOGGSARON_GAZE_THRESHOLD = 15 -- after how many ticks do we fail?

do
    local _, etype, f

    frame:SetScript("OnEvent", function (self, event, ...)
        if event == "COMBAT_LOG_EVENT_UNFILTERED" then
            _, etype = ...
            if etype == "SPELL_MISSED" then etype = "SPELL_DAMAGE" end -- you still suck if you resisted also beware of this hack

            f = lib[etype]

            if f then
                f(lib, ...)
            end

            return
        end

        f = lib[event]

        if f then
            f(lib, ...)
        end
    end)
end


function lib:FailEvent(name, playername)
    callbacks:Fire(name, playername, survivable_fails[name])
end

function lib:GoActive()
    if self.active then return end

    frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    frame:RegisterEvent("PLAYER_REGEN_ENABLED")
    self:InitVariables()

    self.active = true

    callbacks:Fire("Fail_Active")
end


function lib:PLAYER_ENTERING_WORLD(...)
    if GetNumRaidMembers() > 0 then
        self:GoActive()
    else
        self:GoInactive()
    end
end

function lib:RAID_ROSTER_UPDATE(...)
    if GetNumRaidMembers() > 0 then
        self:GoActive()
    else
        self:GoInactive()
    end
end

function lib:PLAYER_REGEN_ENABLED()
    self:InitVariables()
end

function lib:SPELL_DAMAGE(timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, damage, overkill)
    -- Guardian activities ignored after this point
    --5/7 21:13:33.865  SPELL_DAMAGE,0xF1300079F0003A98,"Mirror Image",0x2114,0xF130008092003842,"Elder Stonebark",0xa48,59637,"Fire Blast",0x4,139,0,4,0,0,0,nil,nil,nil
    --5/7 21:13:36.092  SPELL_HEAL,0x01800000007C56B2,"Blackknite",0x512,0xF1300079F0003A97,"Mirror Image",0x2114,54968,"Glyph of Holy Light",0x2,1240,1240,nil
    if bit.band(sourceFlags, COMBATLOG_OBJECT_TYPE_GUARDIAN) > 0 or bit.band(destFlags, COMBATLOG_OBJECT_TYPE_GUARDIAN) > 0 then return end
    local playerevent = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

    -- VAULT OF ARCHAVON

    -- Archavon - Choking Cloud
    if spellId == 58965 or spellId == 61672 then
        if self.LastEvent.Fail_Archavon_ChokingCloud.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Archavon_ChokingCloud.destName) > 3 then
                self:FailEvent("Fail_Archavon_ChokingCloud", destName)
            end
        end

        self.LastEvent.Fail_Archavon_ChokingCloud.destName = timestamp

        return
    end

    -- Emalon - Lightning Nova
    if spellId == 65279 or spellId == 64216 and playerevent and amount > 15000 then
        self:FailEvent("Fail_Emalon_LightningNova", destName)

        return
    end

    -- Emalon - Chaing Lightning
    if spellId == 64213 or spellId == 64215 and playerevent then
        if damage > 10000 then -- at least 3 ppl hugging, and I think highest damage appears in combat log first always (Maat @Ensidiafails)
            self.ThreePeopleHugging = true
            addon:ScheduleTimer("ChainLightningCD", function() lib.ThreePeopleHugging = false end, 3)
        end
        if self.ThreePeopleHugging then
            if self.LastEvent.Fail_Emalon_ChainLightning.destName ~= nil then
                if (timestamp - self.LastEvent.Fail_Emalon_ChainLightning.destName) < 1 then
                    self:FailEvent("Fail_Emalon_ChainLightning", destName)
                end
            end

            self.LastEvent.Fail_Emalon_ChainLightning.destName = timestamp

        end

        return
    end

    -- Koralon - Flame Cinder
    if spellId == 67332 or spellId == 66684 and playerevent then
        if self.LastEvent.Fail_Koralon_FlameCinder.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Koralon_FlameCinder.destName) > 3 then
                self:FailEvent("Fail_Koralon_FlameCinder", destName)
            end
        end

        self.LastEvent.Fail_Koralon_FlameCinder.destName = timestamp

        return
    end

    -- ONYXIA'S LAIR

    -- Onyxia - Deep Breath (when flying, oh yes those are the spellID-s, its not a bug)
    -- The deal with the spellIds is that it depends on WHERE onyxia is, from that point
    -- every breath has 8 corresponding spellId (the farther you are the less dmg, well
    -- those are seperate spells)
    if (spellId >= 17086 and spellId <= 17097) or
       (spellId >= 18351 and spellId <= 18361) or
       (spellId >= 18564 and spellId <= 18576) or
       (spellId >= 18578 and spellId <= 18607) or spellId == 18609 or
       (spellId >= 18611 and spellId <= 18628) or
       (spellId >= 21131 and spellId <= 21139) or spellId == 22267 or spellID == 22268 and playerevent then
        if overkill > 0 or damage > 7000 then
            if self.LastEvent.Fail_Onyxia_DeepBreath.destName ~= nil then
                if (timestamp - self.LastEvent.Fail_Onyxia_DeepBreath.destName) > 5 then
                    self:FailEvent("Fail_Onyxia_DeepBreath", destName)
                end
            else
                self:FailEvent("Fail_Onyxia_DeepBreath", destName)
            end
        end

        self.LastEvent.Fail_Onyxia_DeepBreath.destName = timestamp

        return
    end

    -- Onyxia - Flame Breath (the cone attack)
    if spellId == 68970 or spellId == 18435 and playerevent then -- not a fail for tanks, but we dont care about that here
        self:FailEvent("Fail_Onyxia_FlameBreath", destName)

        return
    end

    -- Onyxia - Tail Sweep
    if spellId == 69286 or spellId == 68867 and playerevent then
        self:FailEvent("Fail_Onyxia_TailSweep", destName)

        return
    end

    -- TRIAL OF THE CRUSADER

    -- Northrend Beasts - Gorehowl - Fire Bomb
    if spellId == 66317 and playerevent then -- the initial damage from whence you have 2 seconds to move
        self.LastEvent.Fail_Gorehowl_FireBomb.destName = timestamp

        return
    elseif spellId == 67472 or spellId == 66320 or spellId == 67475 or spellId == 67473 and playerevent then
        if (timestamp - self.LastEvent.Fail_Gorehowl_FireBomb.destName) > 2 then
            self:FailEvent("Fail_Gorehowl_FireBomb", destName)
            self.LastEvent.Fail_Gorehowl_FireBomb.destName = timestamp -- so as not to spam
        end

        return
    end

    -- Northrend Beasts - Acidmaw - Slime Pool (only trigger on damage, touching the slime pool should'nt be a fail)
    if spellId == 66881 or spellId == 67638 or spellId == 67639 or spellId == 67640 and playerevent then
        if UnitDebuff(destName, GetSpellInfo(67618)) then return end -- Paralytic Toxin (if the dude can't move, let's not fail him/her)

        if self.LastEvent.Fail_Acidmaw_SlimePool.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Acidmaw_SlimePool.destName) > 3 then
                self:FailEvent("Fail_Acidmaw_SlimePool", destName)
            end
        else
            self:FailEvent("Fail_Acidmaw_SlimePool", destName)
        end

        self.LastEvent.Fail_Acidmaw_SlimePool.destName = timestamp

        return
    end

    -- Northrend Beasts - Icehowl - Trample
    if spellId == 66734 and playerevent then
        self:FailEvent("Fail_Icehowl_Trample", destName)

        return
    end

    -- Lord Jaraxxus - Legion Flame
    if spellId == 67072 or spellId == 67070 or spellId == 66877 or spellId == 67071 and overkill > 0 and playerevent then
        self:FailEvent("Fail_Jaraxxus_LegionFlame", destName)

        return
    end

    -- Lord Jaraxxus - Felflame Infernal
    if spellId == 68718 or spellId == 66496 or spellId == 68716 or spellId == 68717 and playerevent then
        if self.LastEvent.Fail_Jaraxxus_FelflameInfernal.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Jaraxxus_FelflameInfernal.destName) > 3 then
                self:FailEvent("Fail_Jaraxxus_FelflameInfernal", destName)
            end
        end

        self.LastEvent.Fail_Jaraxxus_LegionFlame.destName = timestamp

        return
    end

    -- Faction Champions - Hellfire
    if spellId == 65817 or spellId == 68142 or spellId == 68143 or spellId == 68144 and playerevent then
        if self.LastEvent.Fail_FactionChampions_Hellfire.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_FactionChampions_Hellfire.destName) > 3 then
                self:FailEvent("Fail_FactionChampions_Hellfire", destName)
            end
        else
            self:FailEvent("Fail_FactionChampions_Hellfire", destName)
        end

        self.LastEvent.Fail_FactionChampions_Hellfire.destName = timestamp

        return
    end

    -- Twin Val'kyr - Unleashed Light / Dark (the orbs)
    if spellId == 67174 or spellId == 65808 or spellId == 67172 or spellId == 67173 or 
       spellId == 67240 or spellId == 65795 or spellId == 67238 or spellId == 67239 and playerevent then
        self:FailEvent("Fail_Valkyr_Orb", destName)

        return
    end

    -- Twin Val'kyr - Light / Dark Vortex - Non-Heroic (it's a fail only on death)
    if spellId == 67155 or spellId == 67203 or spellId == 66048 or spellId == 66059 and overkill > 0 and playerevent then
        self:FailEvent("Fail_Valkyr_Vortex", destName)

        return
    -- Twin Val'kyr - Light / Dark Vortex - Heroic (it's a fail on the first tick)
    elseif spellId == 67205 or spellId == 67157 or spellId == 67156 or spellId == 67204 and playerevent then
        if self.LastEvent.Fail_Jaraxxus_FelflameInfernal.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Valkyr_Vortex.destName) > 3 then
                self:FailEvent("Fail_Valkyr_Vortex", destName)
            end
        else
            self:FailEvent("Fail_Valkyr_Vortex", destName)
        end

        self.LastEvent.Fail_Valkyr_Vortex.destName = timestamp

        return
    end

    -- Anub'arak - Impale
    if spellId == 67860 or spellId == 67858 or spellId == 67859 and overkill > 0 and playerevent then
        self:FailEvent("Fail_Anubarak_Impale", destName)

        return
    end

    -- ULDUAR

    -- Kologarn Eyebeam
    if spellId == 63976 or spellId == 63346 or spellId == 63368 and playerevent then
        if self.LastEvent.Fail_Kologarn_Eyebeam.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Kologarn_Eyebeam.destName) > 5 then
                self:FailEvent("Fail_Kologarn_Eyebeam", destName)
            end
        else
           self:FailEvent("Fail_Kologarn_Eyebeam", destName)
        end

        self.LastEvent.Fail_Kologarn_Eyebeam.destName = timestamp

        return
    end

    -- Auriaya - Sonic Screech (not standing in it is a fail)
    -- Look in CAST_START for the details
    if spellId == 64688 or spellId == 64422 and playerevent then
        self.RaidTable[destName] = false

        return
    end

    -- Auriaya Void Zone (not a fail if stunned by the kitty)
    if spellId == 64459 or spellId == 64675 and playerevent and not UnitDebuff(destName, GetSpellInfo(64386)) then
        if self.LastEvent.Fail_Auriaya_Voidzone.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Auriaya_Voidzone.destName) > 5 then
                self:FailEvent("Fail_Auriaya_Voidzone", destName)
            end
        else
           self:FailEvent("Fail_Auriaya_Voidzone", destName)
        end

        self.LastEvent.Fail_Auriaya_Voidzone.destName = timestamp

        return
    end

    -- Racorscale Flame
    if spellId == 64733 or spellId == 64704 and playerevent then
        if self.LastEvent.Fail_Racorscale_Flame.destName == nil then
           self.LastEvent.Fail_Racorscale_Flame.destName = 0
        end

        self.LastEvent.Fail_Racorscale_Flame.destName = self.LastEvent.Fail_Racorscale_Flame.destName + 1

        if self.LastEvent.Fail_Racorscale_Flame.destName == 2 then
           self:FailEvent("Fail_Racorscale_Flame", destName)
           self.LastEvent.Fail_Racorscale_Flame.destName = 0
        end

        return
    end

    -- Yogg Saron Death Ray
    if spellId == 63884 or spellId == 63891 and playerevent then
        if self.LastEvent.Fail_Yogg_DeathRay.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Yogg_DeathRay.destName) > 5 then
                self:FailEvent("Fail_Yogg_DeathRay", destName)
            end
        else
           self:FailEvent("Fail_Yogg_DeathRay", destName)
        end

        self.LastEvent.Fail_Yogg_DeathRay.destName = timestamp

        return
    end

    -- Yogg-Saron - Lunatic Gaze
    if spellId == 64168 or spellId == 64164 and playerevent then
        if not self.LunaticGaze[ destName ] then self.LunaticGaze = 1 end

        if spellId == 64168 then -- Yogg-Saron's lunatic gaze, not so serious
            self.LunaticGaze[destName] = self.LunaticGaze[destName] + 1
        else -- Laughing Skull's lunatic gaze, more serious
            self.LunaticGaze[destName] = self.LunaticGaze[destName] + 2
        end

        if self.LunaticGaze[destName] >= self.YOGGSARON_GAZE_THRESHOLD then
            self.LunaticGaze[destName] = 0
            self:FailEvent("Fail_Yogg_LunaticGaze", destName)
        end

        return
    end

    -- Algalon - Big Bang
    if spellId == 64584 or spellId == 64443 and playerevent then
        self:FailEvent("Fail_Algalon_BigBang", destname)

        return
    end

    -- Freya Nature Bomb
    if spellId ==64650 and playerevent then
         self:FailEvent("Fail_Freya_NatureBomb", destName)

         return
    end

    -- Hodir Icicle (aka Ice Shards)
    if spellId == 62457 or spellId == 65370 and playerevent then
         self:FailEvent("Fail_Hodir_Icicle", destName)

         return
    end

    -- EnsidiaFails - Maat
    -- Hodir Biting Cold
    if spellId == 62038 or spellId == 62188 and playerevent then
        local _, _, _, stack = UnitDebuff(destName, GetSpellInfo(62188))

        if stack ~= nil and stack > 2 then
            if self.LastEvent.Fail_Hodir_BitingCold.destName == nil or (timestamp - self.LastEvent.Fail_Hodir_BitingCold.destName) > 5 then
                self:FailEvent("Fail_Hodir_BitingCold", destName)
                self.LastEvent.Fail_Hodir_BitingCold.destName = timestamp
            end
        end

        return
    end

    -- Council Overload
    if spellId == 61878 or spellId == 63480 and playerevent and damage > 2500 then -- DKs with AMS shouln't fail
         self:FailEvent("Fail_Council_Overload", destName)

         return
    end

    -- XT-002 Deconstructor: Light Bomb
    if spellId == 65120 and sourceGUID ~= destGUID and playerevent then
        if self.LastLight[sourceName] ~= nil then
            if (timestamp - lib.LastLight[sourceName]) > 4 then
                self:FailEvent("Fail_Deconstructor_Light", sourceName)
            end
            self.LastLight[sourceName] = nil
        end

        return
    end

    -- XT-002 Deconstructor: Gravity Bomb (bomb part)
    if spellId == 64233 and sourceGUID ~= destGUID and playerevent then
        if self.LastGravity[sourceName] ~= nil then
            self:FailEvent("Fail_Deconstructor_Void", sourceName)
            self.LastGravity[sourceName] = nil
        end

        return
    end

    -- XT-002 Deconstructor - Void Zone (on heroic, what the gravity bomb leaves behind)
    --5/7 18:19:04.078  SPELL_DAMAGE,0xF1300084D1002E23,"Void Zone",0xa48,0x0300000001D3239F,"Diomache",0x514,64208,"Consumption",0x20,6258,0,32,0,0,0,nil,nil,nil
    if spellId == 64208 or spellId == 64206 and playerevent then
        self:FailEvent("Fail_Deconstructor_Voidzone", destName)

        return
    end

   -- Failbot - Viiv
   -- 4/16 21:10:24.039  SPELL_DAMAGE,0xF1300083EC02D966,"Faceless Horror",0x10a48,0x05000000027ECC71,"Boniface",0x514,63721,"Shadow Crash",0x20,8103,0,32,2457,0,0,nil,nil,nil
   -- 4/16 22:06:17.885  SPELL_DAMAGE,0xF1300081F702D928,"General Vezax",0x10a48,0x05000000027FCDFE,"Kosie",0x514,62659,"Shadow Crash",0x20,9413,0,32,2285,0,0,nil,nil,nil
   -- Vezax Shadow Crash
    if spellId == 62659 or spellId == 63721 or spellId == 63277 and playerevent then
        self:FailEvent("Fail_Vezax_ShadowCrash", destName)

        return
    end

    -- Vezax Saronite Vapor Suicide
    if spellId == 63338 and playerevent then
         self.LastEvent.Fail_Vezax_Saronite.destName = timestamp

         return
    end

   -- Failbot - Viiv
   -- 4/16 18:20:24.295  SPELL_DAMAGE,0xF130008061018374,"Thorim",0x8010a48,0x0500000001E8AF39,"Thefeint",0x514,62466,"Lightning Charge",0x8,8977,0,8,3966,0,0,nil,nil,nil
   -- Thorim Lightning Charge
    if spellId == 62466 and playerevent then
        self:FailEvent("Fail_Thorim_LightningCharge", destName)

        return
    end

    -- Thorim Chain Lightning
    if spellId == 64390 and playerevent then
        -- The event starts from the end of the chain and works back to the start. Who failed?
        -- Need a way of expressing group failures
        self:FailEvent("Fail_Thorim_LightningChain", destName)

        return
    end

    -- 4/16 01:06:26.414  SPELL_DAMAGE,0x0000000000000000,nil,0x80000000,0x05000000027ECA9C,"Cn",0x514,62465,"Runic Smash",0x4,6544,0,4,3116,0,0,nil,nil,nil
    -- Thorim Hallway Smash
    if spellId == 62465 and playerevent then
        self:FailEvent("Fail_Thorim_Smash", destName)

        return
    end

    -- Failbot - Viiv
    -- 4/16 18:50:56.578  SPELL_DAMAGE,0x0000000000000000,nil,0x80000000,0x05000000027ECB89,"Logicalness",0x514,64875,"Sapper Explosion",0x40,67542,45099,64,28421,0,0,nil,nil,nil
    -- Mimiron Trash - Sapper Explosion
    if spellId == 64875 and playerevent then
        self:FailEvent("Fail_Boss_Sapper", destName)

        return
    end

    -- Mimiron Flames
    -- oscarucb: report when someone takes 2 ticks in under 3 seconds
    if spellId == 64566 and playerevent then
        if self.LastEvent.Fail_Mimiron_Flames.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Mimiron_Flames.destName) < 3 then
                self:FailEvent("Fail_Mimiron_Flames", destName)
            end
        else
           self:FailEvent("Fail_Mimiron_Flames", destName)
        end

        self.LastEvent.Fail_Mimiron_Flames.destName = timestamp

        return
    end

    -- Mimiron - Water Spray
    if spellId == 64619 and playerevent then
        self:FailEvent("Fail_Mimiron_WaterSpray", destName)

        return
    end

    -- Mimiron - Proximity Mine (should check for sourcename == proximity mine?)
    if spellId == 63009 or spellId == 66351 and playerevent then
        if self.LastEvent.Fail_Mimiron_ProximityMine ~= nil then
            if (timestamp - self.LastEvent.Fail_Mimiron_ProximityMine.destName) > 3 then
                self:FailEvent("Fail_Mimiron_ProximityMine", destName)
            end
        else
            self:FailEvent("Fail_Mimiron_ProximityMine", destName)
        end

        self.LastEvent.Fail_Mimiron_ProximityMine.destName = timestamp

        return
    end

    -- Mimiron - Frost Bomb
    if spellId == 65333 or spellId == 64626 and playerevent then
        self:FailEvent("Fail_Mimiron_FrostBomb", destName)

        return
    end

    -- Mimiron Laser Barrage
    if spellId == 63293 and playerevent then
        if self.LastEvent.Fail_Mimiron_LaserBarrage.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Mimiron_LaserBarrage.destName) > 10 then
                self:FailEvent("Fail_Mimiron_LaserBarrage", destName)
            end
        else
           self:FailEvent("Fail_Mimiron_LaserBarrage", destName)
        end

        self.LastEvent.Fail_Mimiron_LaserBarrage.destName = timestamp

        return
    end

    -- Mimiron Rocket Strike
    if spellId == 63041 and playerevent then
        self:FailEvent("Fail_Mimiron_Rocket", destName)

        return
    end

   -- Failbot - Viiv
   -- 4/16 13:35:12.750  SPELL_DAMAGE,0xF13000842C0094E3,"Bomb Bot",0xa48,0x05000000027ECCA5,"Naddia",0x512,63801,"Bomb Bot",0x4,20216,4025,4,5054,0,0,nil,nil,nil
   -- Mimiron Bomb Bots
   if spellId == 63801 and playerevent then
       if timestamp - (self.SquelchFail.Fail_Mimiron_BombBots or 0) <= 0 then
          return
       end
       self:FailEvent("Fail_Mimiron_BombBots", destName)

       return
   end

    -- 3/13 21:17:23.756  SPELL_DAMAGE,0xF150008298002210,"Leviathan Mk II",0x10a48,0xF1300007AC0025A9,"Treant",0x1114,63631,"Shock Blast",0x8,97000,92908,8,0,0,0,nil,nil,nil
    -- Mimiron Shock Blast
    if spellId == 63631 and playerevent then
        self:FailEvent("Fail_Mimiron_Shock", destName)

        return
    end

    -- OBSIDIAN SANCTUM

    -- Sartharion Lava Waves: Flame Tsunami
    if spellId == 57491 and playerevent then
        if self.LastTsunami[destName] == nil then
            self.LastTsunami[destName] = timestamp

            self:FailEvent("Fail_Sartharion_LavaWaves", destName)
        else
            if (timestamp - lib.LastTsunami[destName]) > 10 then
                self:FailEvent("Fail_Sartharion_LavaWaves", destName)
            end
            self.LastTsunami[destName] = timestamp
        end

        return
    end

    -- Sartharion - Void Zone
    if spellId == 57581 or spellId == 59128 and playerevent then
        self:FailEvent("Fail_Sartharion_VoidZone", destName)

        return
    end

    -- NAXXRAMAS

    -- The Four Horsemen - Voide Zone
    if spellId == 28865 and playerevent then
        if self.LastEvent.Fail_Horsemen_VoideZone.destName ~= nil then
            if (timestamp - self.LastEvent.Fail_Horsemen_VoideZone.destName) > 3 then
                self:FailEvent("Fail_Horsemen_VoideZone", destName)
            end
        else
            self:FailEvent("Fail_Horsemen_VoideZone", destName)
        end

        self.LastEvent.Fail_Horsemen_VoideZone.destName = timestamp

        return
    end

    -- The Four Horsemen - Mark death
    if spellId == 28836 and playerevent and overkill > 0 then
        self:FailEvent("Fail_Horsemen_Mark", destName)

        return
    end

    -- Heigan - Eruption (aka dance fail)
    if spellId == 29371 and playerevent then
        self:FailEvent("Fail_Heigan_Dance", destName)

        return
    end

    -- Kel'Thuzad - Void Blast (aka Void Zone)
    if spellId == 27812 and playerevent then
        self:FailEvent("Fail_KelThuzad_VoidZone", destName)

        return
    end

    -- Sapphiron - Frost Breath
    if spellId == 28524 and playerevent then
        self:FailEvent("Fail_Sapphiron_Breath", destName)

        return
    end

    if spellId == 28433 and playerevent then
        self.FroggerTime[destName] = timestamp

        return
    end

    -- Thaddius Polarity Switch
    -- 28062 Positive Charge
    -- 28085 Negative Charge
    if spellId == 28062  or spellId == 28085 and self.ThaddiusAlive then
        if self.ChargeCounter[sourceName] == nil then
            self.ChargeCounter[sourceName] = 1
            self.LastCharge[sourceName] = timestamp
        elseif (timestamp - self.LastCharge[sourceName]) < 2 then
            self.ChargeCounter[sourceName] = self.ChargeCounter[sourceName] + 1
            self.LastCharge[sourceName] = timestamp
        else
            self.ChargeCounter[sourceName] = 1
            self.LastCharge[sourceName] = timestamp
        end

        if self.ChargeCounter[sourceName] == 3 then
            self:FailEvent("Fail_Thaddius_PolaritySwitch", sourceName)
        end

        return
    end
end


function lib:ENVIRONMENTAL_DAMAGE(timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, dmgType)
    local playerevent = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

    -- Thaddius Falling
    if (timestamp - self.DeathTime) < self.THADDIUS_JUMP_WINDOW and dmgType == "FALLING" and playerevent then
        self.LastSlime[destName] = timestamp
        self:FailEvent("Fail_Thaddius_Jump", destName)

        return
    end
end

-- Thaddius Polarity Shift
function lib:SPELL_CAST_START(timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool)
    -- local playerevent = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

    -- Thaddius
    if spellId == 28089 then
        self.ThaddiusAlive = true;

        return
    end

    -- Auriaya - Sonic Screech
    -- The raid table is initialized in this form: "playername" => true
    -- in SPELL_DAMAGE above, we set those to false who get the damage 
    -- and check here for who is still true, we also reset the whole thing
    -- so it can be reused in in the fight (InitRaidtable will return
    -- if the table is already filled)
    if spellId == 64688 or spellId == 64422 then
        self:InitRaidTable()
        self:ScheduleTimer("AuriayaScreech", function()
            for name, failed in pairs(lib.RaidTable) do
                if failed then
                    lib:FailEvent("Fail_Auriaya_SonicScreech", name)
                else
                    lib.RaidTable[name] = true
                end
            end
        end, 4)
        return
    end

    -- Algalon - Big Bang timer
    if spellId == 64584 or spellId == 64443 then
        self.BigbangCasting = true
        self:ScheduleTimer("Algalon_BigBang", function() lib.BigbangCasting = false end, 8)

        return
    end
end

function lib:UNIT_DIED(timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags)
    local playerevent = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0
    local mobid -- 3.3 compat code
    if QueryQuestsCompleted then
        mobid = destGUID and tonumber(destGUID:sub(-12, -9), 16) or false
    else
        mobid = destGUID and tonumber(destGUID:sub(-12, -7), 16) or false
    end

    -- 15929 stalagg 15930 feugen for thaddius fails
    if mobid == 15929 or mobid == 15930 then
        self.DeathTime = timestamp

        return
    end

    if self.FroggerTime[destName] then
        if (timestamp - self.FroggerTime[destName]) < self.FROGGER_DEATH_WINDOW and playerevent then
           self:FailEvent("Fail_Frogger", destName)
        end

        self.FroggerTime[destName] = nil

        return
    end

    -- Saronite Vapor Suicide (Fail_Vezax_Saronite) death within 2sec of saronite damage
    if self.LastEvent.Fail_Vezax_Saronite.destName then
        if (timestamp - self.LastEvent.Fail_Vezax_Saronite.destName) < 2 then
            self:FailEvent("Fail_Vezax_Saronite", destName)
        end

        self.LastEvent.Fail_Vezax_Saronite.destName = nil
    end


end

function lib:SPELL_PERIODIC_DAMAGE(timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, damaga, overkill)
    local playerevent = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

    -- Northrend Beasts - Acidmaw - Paralytic Toxin
    if spellId == 67618 or spellId == 67619 or spellId == 67620 or spellId == 66823 and overkill > 0 and playerevent then
        self:FailEvent("Fail_Acidmaw_ParalyticToxin", destName)

        return
    end

    -- Freya Sunbeam
    if spellId == 62865 or spellId == 62451 and playerevent then
        if self.LastEvent.Fail_Freya_Sunbeam.destName == nil then
           self.LastEvent.Fail_Freya_Sunbeam.destName = 0
        end

        self.LastEvent.Fail_Freya_Sunbeam.destName = self.LastEvent.Fail_Freya_Sunbeam.destName + 1

        if self.LastEvent.Fail_Freya_Sunbeam.destName == 2 then
           self:FailEvent("Fail_Freya_Sunbeam", destName)
           self.LastEvent.Fail_Freya_Sunbeam.destName = 0
        end

        return
    end

    -- Thorim Blizzard
    if spellId == 62602 or spellId == 62576 and playerevent then
        if self.LastEvent.Fail_Thorim_Blizzard.destName == nil then
           self.LastEvent.Fail_Thorim_Blizzard.destName = 0
        end

        self.LastEvent.Fail_Thorim_Blizzard.destName = self.LastEvent.Fail_Thorim_Blizzard.destName + 1

        if self.LastEvent.Fail_Thorim_Blizzard.destName == 2 then
           self:FailEvent("Fail_Thorim_Blizzard", destName)
           self.LastEvent.Fail_Thorim_Blizzard.destName = 0
        end

        return
    end
end

function lib:SPELL_HEAL(timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool)
    -- local playerevent = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

    -- Vezax Mark of the Faceless
    if spellId == 63278 then
        if self.SquelchFail.Fail_Vezax_Leech > 2 then -- allow 2 healing ticks before it's a fail
            self:FailEvent("Fail_Vezax_Leech", self.LastEvent.Fail_Vezax_Leech)
        else
            self.SquelchFail.Fail_Vezax_Leech = self.SquelchFail.Fail_Vezax_Leech + 1
        end

        return
    end
end

function lib:SPELL_AURA_APPLIED(timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool)
    local playerevent = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

    -- Northrend Beasts - Dreadscale - Molten Spew (the cone attack (breath))
    if spellId == 63276 and playerevent then
        self:FailEvent("Fail_Dreadscale_MoltenSpew", destName)

        return
   end

    -- Northrend Beasts - Acidmaw - Acidic Spew (the cone attack (breath))
    if spellId == 66818 and playerevent then
        self:FailEvent("Fail_Acidmaw_AcidicSpew", destName)

        return
   end

    -- Vezax Mark of the Faceless
    if spellId == 63276 and playerevent then
        -- save the name of the player who gain mark of the faceless
        self.LastEvent.Fail_Vezax_Leech = destName

        -- reset the heal count
        self.SquelchFail.Fail_Vezax_Leech = 0

        return
   end

   -- Hodir Flash Freeze
    if spellId == 61969 or spellId == 61990 and playerevent then
        self:FailEvent("Fail_Hodir_FlashFreeze")

        return
    end

    -- Yogg Saron Sanity Lost
    if spellId == 63120 and playerevent then
        self:FailEvent("Fail_Yogg_Sanity")

        return
    end

    -- Thaddius Jump
    if spellId == 28801 and (timestamp - self.DeathTime) < self.THADDIUS_JUMP_WINDOW and playerevent then
        if self.LastSlime[destName] == nil then
            self:FailEvent("Fail_Thaddius_Jump", destName)
        elseif (timestamp - self.LastSlime[destName]) > self.THADDIUS_JUMP_RETRY_WINDOW then
            self:FailEvent("Fail_Thaddius_Jump", destName)
        end

        return
    end

    -- Algalon - Black Hole (if big bang is not casting, it's a fail)
    if spellId == 62169 and playerevent and not self.BigbangCasting then
        self:FailEvent("Fail_Algalon_Blackhole", destName)

        return
    end

    -- Light Bomb
    if spellId == 65120 and playerevent then
        self.LastLight[destName] = timestamp

        return
    end

    -- Mimiron - Deafening Siren
    if spellId == 64616 and playerevent then
        self:FailEvent("Fail_Mimiron_Siren", destName)

        return
    end

    -- Koralon the Flame Watcher - Meteor Fist (a fail if a non-tank gets it, let "userspace" handle it)
    if spellId == 64616 and playerevent then
        self:FailEvent("Fail_Koralon_MeteorFist", destName)

        return
    end
end

function lib:SPELL_SUMMON(timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName)
    -- local playerevent = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

    --SPELL_SUMMON,0xF15000838601084D,"Aerial Command Unit",0xa48,0xF13000842C010A24,"Bomb Bot",0xa28,63811,"Bomb Bot",0x1
    if spellId == 63811 then
        -- could add the GUID for each bot if this doesnt work.
        self.SquelchFail.Fail_Mimiron_BombBots = timestamp + 30

        return
    end
end


function lib:SPELL_AURA_REMOVED(timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool)
    local playerevent = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

    -- Malygos Phase3 Dot
    if spellId == 56092 or spellId == 61621 and self.MalygosAlive then
        local failer = nil

        for raidid = 1, GetNumRaidMembers() do
            local pet = format("%s%d", "raidpet", raidid);

            if (UnitGUID(pet) == sourceGUID) then
                if UnitHealth(pet) > 0 then
                    local member = format("%s%d", "raid", raidid);
                    failer = UnitName(member);
                else
                    failer = nil;
                end
            end
        end

        if failer ~= nil then
            self:FailEvent("Fail_Malygos_Dot", failer)
        end
    end

    -- Thaddius Jump
    if spellId == 28801 and (timestamp - self.DeathTime) < self.THADDIUS_JUMP_WINDOW and playerevent then
        self.LastSlime[destName] = timestamp

        return
    end

    -- Light Bomb
    if spellId == 65120 then
        self.LastLight[destName] = nil

        return
    end

    -- Gravity Bomb
    if spellId == 64233 then
        self.LastGravity[destName] = timestamp

        return
    end
end
